/* Copyright Xanadu Operating Company.  All Rights Reserved. */

/******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Xanadu    *
* Operating Company, and considered a trade secret as defined in section     * 
* 499C of the penal code of the State of California.  Use of this information* 
* by anyone other than authorized employees of Xanadu is granted             *
* only under a  written non-disclosure agreement, expressly prescribing      * 
* the scope and  manner of such use.                                         *
*                                                                            *
***************************************************************************
Output from Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989
*/

#ifndef GRANMAPX_CXX
#define GRANMAPX_CXX


#ifndef CHOOSEX_HXX
#include "choosex.hxx"
#endif /* CHOOSEX_HXX */

#ifndef GRANMAPX_HXX
#include "granmapx.hxx"
#endif /* GRANMAPX_HXX */

#ifndef GRANMAPX_IXX
#include "granmapx.ixx"
#endif /* GRANMAPX_IXX */

#ifndef GRANMAPP_HXX
#include "granmapp.hxx"
#endif /* GRANMAPP_HXX */

#ifndef GRANMAPP_IXX
#include "granmapp.ixx"
#endif /* GRANMAPP_IXX */


#ifndef BRANGE1X_HXX
#include "brange1x.hxx"
#endif /* BRANGE1X_HXX */

#ifndef BRANGE2X_HXX
#include "brange2x.hxx"
#endif /* BRANGE2X_HXX */

#ifndef CANOPYX_HXX
#include "canopyx.hxx"
#endif /* CANOPYX_HXX */

#ifndef COOKBKX_HXX
#include "cookbkx.hxx"
#endif /* COOKBKX_HXX */

#ifndef DISKMANX_HXX
#include "diskmanx.hxx"
#endif /* DISKMANX_HXX */

#ifndef FLUIDX_HXX
#include "fluidx.hxx"
#endif /* FLUIDX_HXX */

#ifndef GRANTABX_HXX
#include "grantabx.hxx"
#endif /* GRANTABX_HXX */

#ifndef HSPACEX_HXX
#include "hspacex.hxx"
#endif /* HSPACEX_HXX */

#ifndef HTREEX_HXX
#include "htreex.hxx"
#endif /* HTREEX_HXX */

#ifndef INTEGERX_HXX
#include "integerx.hxx"
#endif /* INTEGERX_HXX */

#ifndef LOAVESX_HXX
#include "loavesx.hxx"
#endif /* LOAVESX_HXX */

#ifndef NADMINX_HXX
#include "nadminx.hxx"
#endif /* NADMINX_HXX */

#ifndef NKERNELX_HXX
#include "nkernelx.hxx"
#endif /* NKERNELX_HXX */

#ifndef NXCVRX_HXX
#include "nxcvrx.hxx"
#endif /* NXCVRX_HXX */

#ifndef OROOTX_HXX
#include "orootx.hxx"
#endif /* OROOTX_HXX */

#ifndef PRIMVALX_HXX
#include "primvalx.hxx"
#endif /* PRIMVALX_HXX */

#ifndef RECIPEX_HXX
#include "recipex.hxx"
#endif /* RECIPEX_HXX */

#ifndef SPACEX_HXX
#include "spacex.hxx"
#endif /* SPACEX_HXX */

#ifndef TRACEPX_HXX
#include "tracepx.hxx"
#endif /* TRACEPX_HXX */

#ifndef WRAPPERX_HXX
#include "wrapperx.hxx"
#endif /* WRAPPERX_HXX */




/* ************************************************************************ *
 * 
 *                    Class BeGrandMap 
 *
 * ************************************************************************ */



/* Initializers for BeGrandMap */

BUILD_FLUID(BeGrandMap,CurrentGrandMap, NULL, DiskManager::emulsion());	/* in BeGrandMap */

/* global: time */


IntegerVar  xuTime (){
	/* Seconds since the beginning of time */
	
	/* Known bug !!!! */
	
	return 3;
	
	
}

/* Initializers for BeGrandMap */



/* private: pseudo constructors */


RPTR(BeGrandMap) BeGrandMap::make (){
	RETURN_CONSTRUCT(BeGrandMap,(Sequence::two(666, 42), tcsj));
}
/* Rewrite notes
3/7/92 ravi
- we had decided to have myRangeElementIDs be a GrandSetTable, but 
for now its just a Table onto IDRegions, since that is what we have 
implemented right now */


/* private: booting */


void BeGrandMap::clubConsistencyCheck (){
	/* Check that the BeClub structure matches the Editions 
	underneath them */
	
	/* Ravi -- Thing to do !!!! */
	
}


void BeGrandMap::coldBoot (){
	SPTR(FeEdition) emptyDesc;
	SPTR(BeClub) emptyClub;
	SPTR(FeEdition) publicDesc;
	SPTR(BeClub) publicClub;
	SPTR(BeClub) adminClub;
	SPTR(BeClub) archiveClub;
	SPTR(BeEdition) clubNames;
	SPTR(MuTable) OF2(Sequence,CrossRegion) endorsements;
	IntegerVar number;
	SPTR(IDSpace) iDSpace;
	SPTR(BeEdition) endorseTokenWorks;
	
	/* set up the initial set of Clubs */
	myEmptyClubID = 
			ID::make (NULL, NULL, -1);
	myPublicClubID = 
			ID::make (NULL, NULL, -2);
	/* Thing to do !!!! */
	
	/* ensure that the following IDs are deterministic */
	myAdminClubID = myGlobalIDSpace->newID();
	myArchiveClubID = myGlobalIDSpace->newID();
	myAccessClubID = myGlobalIDSpace->newID();
	/* figure out the IDs of the Wrapper endorsement Works */
	endorsements = MuTable::make (SequenceSpace::make ());
	number = -3;
	BEGIN_FOR_EACH(Sequence,name,(FeWrapperSpec::knownWrappers()->stepper())) {
		SPTR(ID) iD;
		
		/* Ravi -- Thing to do !!!! */
		
		/* put something more descriptive here */
		iD = 
				ID::make (NULL, NULL, number);
		number -= 1;
		endorsements->introduce(name, myEndorsementSpace->crossOfRegions(CAST(PtrArray,PrimSpec::pointer()->arrayWithTwo(myArchiveClubID->asRegion(), iD->asRegion()))));
	} END_FOR_EACH;
	myWrapperEndorsements = endorsements->asImmuTable();
	/* set up the special flag bits used by the canopy */
	myEndorsementFlags = PtrArray::nulls(5 + 10);
	myEndorsementFlags->store(UInt32Zero, CAST(XnRegion,endorsements->get(Sequence::string("Text")))->theOne());
	myEndorsementFlags->store(1, CAST(XnRegion,endorsements->get(Sequence::string("HyperLink")))->theOne());
	myEndorsementFlags->store(2, CAST(XnRegion,endorsements->get(Sequence::string("HyperRef")))->theOne());
	myEndorsementFlags->store(3, CAST(XnRegion,endorsements->get(Sequence::string("SingleRef")))->theOne());
	myEndorsementFlags->store(4, CAST(XnRegion,endorsements->get(Sequence::string("MultiRef")))->theOne());
	/* generate some IDs to use as endorsement tokens */
	{
		Int32 LoopFinal = myEndorsementFlags->count();
		Int32 i = 5;
		for (;;) {
			if (i >= LoopFinal){
				break;
			}
			{
				myEndorsementFlags->store(i, myEndorsementSpace->crossOfRegions(CAST(PtrArray,PrimSpec::pointer()->arrayWithTwo(myGlobalIDSpace->fullRegion(), myGlobalIDSpace->newID()->asRegion()))));
			}
			i += 1;
		}
	}
	CanopyCrum::useEndorsementFlags(myEndorsementFlags);
	CurrentAuthor.fluidSet(myEmptyClubID);
	InitialReadClub.fluidSet(myPublicClubID);
	InitialEditClub.fluidSet(myEmptyClubID);
	InitialOwner.fluidSet(myEmptyClubID);
	InitialSponsor.fluidSet(myEmptyClubID);
	/* Known bug !!!! */
	
	/* Who sponsors clubs? */
	emptyDesc = CAST(FeEdition,this->carrier(this->newEmptyEdition(SequenceSpace::make ()))->makeFe());
	emptyClub = this->newClub(emptyDesc, myEmptyClubID);
	emptyClub->setEditClub(NULL);
	publicDesc = CAST(FeEdition,this->carrier(this->newEditionWith(Sequence::string("ClubDescription:LockSmith"), this->carrier(
										this->newDataEdition(UInt8Array::string("boo"), IntegerRegion::make (IntegerVarZero, 3), IntegerSpace::make ()->getAscending()))))->makeFe());
	publicClub = this->newClub(publicDesc, myPublicClubID);
	publicClub->setEditClub(NULL);
	emptyClub->sponsor(CAST(IDRegion,myPublicClubID->asRegion()));
	publicClub->sponsor(CAST(IDRegion,myPublicClubID->asRegion()));
	InitialSponsor.fluidSet(myPublicClubID);
	InitialReadClub.fluidSet(myAdminClubID);
	InitialEditClub.fluidSet(myAdminClubID);
	InitialOwner.fluidSet(myAdminClubID);
	/* Thing to do !!!! */
	
	/* This should probably still be the Null Club. */
	adminClub = this->newClub(publicDesc, myAdminClubID);
	InitialReadClub.fluidSet(myArchiveClubID);
	InitialEditClub.fluidSet(myArchiveClubID);
	InitialOwner.fluidSet(myArchiveClubID);
	archiveClub = this->newClub(publicDesc, myArchiveClubID);
	CurrentKeyMaster.fluidSet(FeKeyMaster::make (this->publicClubID()));
	InitialReadClub.fluidSet(myAdminClubID);
	InitialEditClub.fluidSet(myAdminClubID);
	iDSpace = IDSpace::unique();
	this->newClub(CAST(FeEdition,this->carrier(this->newEditionWith(Sequence::string("ClubDescription:Membership"), this->carrier(this->newEditionWith(iDSpace->newID(), this->carrier(publicClub))->with(iDSpace->newID(), this->carrier(adminClub))->with(iDSpace->newID(), this->carrier(archiveClub)))))->makeFe()), myAccessClubID);
	InitialReadClub.fluidSet(myPublicClubID);
	InitialSponsor.fluidSet(myAdminClubID);
	InitialEditClub.fluidSet(myAdminClubID);
	clubNames = this->newEditionWith(Sequence::string("System Admin"), this->carrier(adminClub))->combine(this->newEditionWith(Sequence::string("System Archive"), this->carrier(archiveClub)))->combine(this->newEditionWith(Sequence::string("Universal Null"), this->carrier(emptyClub)))->combine(this->newEditionWith(Sequence::string("Universal Public"), this->carrier(publicClub)));
	myClubDirectoryID = this->assignID(this->newWork(FeEdition::on(clubNames)));
	/* actually create the Wrapper description Works */
	BEGIN_FOR_POSITIONS(Sequence,name,CrossRegion,end,(endorsements->stepper())) {
		/* Ravi -- Thing to do !!!! */
		
		/* put something more descriptive in the Work */
		this->tryIntroduce(CAST(ID,CAST(Tuple,end->theOne())->coordinate(1)), this->newWork(FeEdition::on(
								this->newDataEdition(name->integers(), IntegerRegion::make (IntegerVarZero, name->integers()->count()), IntegerSpace::make ()->ascending()))));
	} END_FOR_POSITIONS;
	/* actually create the endorsement token Works */
	iDSpace = IDSpace::unique();
	endorseTokenWorks = this->newEmptyEdition(iDSpace);
	{
		Int32 LoopFinal = myEndorsementFlags->count();
		Int32 i = 5;
		for (;;) {
			if (i >= LoopFinal){
				break;
			}
			{
				SPTR(BeWork) work;
				
				work = this->newWork(emptyDesc);
				/* contents don't matter */
				this->tryIntroduce(CAST(ID,CAST(IDRegion,CAST(CrossRegion,myEndorsementFlags->get(i))->projection(1))->theOne()), work);
				endorseTokenWorks = endorseTokenWorks->with(iDSpace->newID(), this->carrier(work));
			}
			i += 1;
		}
	}
	/* attach & endorse them so they can be found */
	{	FLUID_BIND(InitialReadClub,myAdminClubID) {
			{	FLUID_BIND(InitialEditClub,NULL) {
					SPTR(BeEdition) edition;
					
					edition = this->newEditionWith(Sequence::string("Universal Public"), this->carrier(publicClub))->with(Sequence::string("Fast Tokens"), this->carrier(endorseTokenWorks));
					this->newWork(FeEdition::on(edition));
					edition->endorse(myEndorsementSpace->crossOfRegions(CAST(PtrArray,PrimSpec::pointer()->arrayWithTwo(myEmptyClubID->asRegion(), myEmptyClubID->asRegion()))));
				}
			}
		}
	}
	myGateLockSmithEdition = 
			this->newDataEdition(UInt8Array::string("wall"), IntegerRegion::make (IntegerVarZero, 4), IntegerSpace::make ()->ascending());
	myGrants = this->newEditionWithAll(myGlobalIDSpace->fullRegion(), this->carrier(adminClub));
	InitialOwner.fluidSet((ID * ) NULL);
	InitialSponsor.fluidSet((ID * ) NULL);
	InitialReadClub.fluidSet(myEmptyClubID);
	InitialEditClub.fluidSet((ID * ) NULL);
	CurrentAuthor.fluidSet((ID * ) NULL);
	CurrentKeyMaster.fluidSet((FeKeyMaster * ) NULL);
}
/* private: create */


BeGrandMap::BeGrandMap (APTR(Sequence) identifier, TCSJ) {
	BEGIN_CONSISTENT(-1) {
		SPTR(Counter) counter;
		
		this->newShepherd();
		/* newShepherd must be first in GrandMap so that it 
			is the boot object. */
		myPurgeable = FALSE;
		/* The GrandMap cannot be purged until it is 
			explicitly allowed. */
		myEnt = Ent::make ();
		myIdentifier = identifier;
		/* The counters table must be setup before we try to 
			make any IDSpaces */
		myIDCounters = MuTable::make (CrossSpace::make (SequenceSpace::make (), IntegerSpace::make ()));
		counter = Counter::make (1, 20);
		myGlobalIDSpace = 
				IDSpace::make (NULL, -1, counter);
		myIDCounters->introduce(Tuple::two(Sequence::zero(), IntegerPos::make (-1)), counter);
		myLocalIDSpaceCounter = Counter::make (1, 256);
		myGlobalIDFilterSpace = FilterSpace::make (CAST(CoordinateSpace,myGlobalIDSpace));
		myEndorsementSpace = CrossSpace::make (CAST(PtrArray,PrimSpec::pointer()->arrayWithTwo(myGlobalIDSpace, myGlobalIDSpace)));
		myEndorsementFilterSpace = FilterSpace::make (CAST(CoordinateSpace,myEndorsementSpace));
		myRangeElements = GrandHashTable::make (myGlobalIDSpace);
		myIDHolders = GrandHashTable::make (myGlobalIDSpace);
		myRangeElementIDs = GrandHashTable::make (HeaperSpace::make ());
		/* Hack !!!! */
		
		/* how does this connect */
		{	FLUID_BIND(CurrentGrandMap,this) {
				this->coldBoot();
			}
		}
		this->remember();
	} END_CONSISTENT;
	{	FLUID_BIND(CurrentGrandMap,this) {
			this->clubConsistencyCheck();
		}
	}
	myPurgeable = FALSE;
	myAcceptingConnectionsFlag = TRUE;
}
/* hooks: */


void BeGrandMap::restartBeGrandMap (APTR(Rcvr) /* rcvr */){
	myPurgeable = FALSE;
	myAcceptingConnectionsFlag = TRUE;
	CanopyCrum::useEndorsementFlags(myEndorsementFlags);
}
/* purging */


void BeGrandMap::bePurgeable (){
	/* Allow the GrandMap to be purged.  The GrandMap should NOT 
	be used after this is called. */
	
	myPurgeable = TRUE;
}


BooleanVar BeGrandMap::isPurgeable (){
	/* The Grandmap never gets purged unless explicitly allowed 
	by calling bePurgeable. */
	
	return myPurgeable;
}
/* testing */


UInt32 BeGrandMap::contentsHash (){
	return this->Abraham::contentsHash() ^ myIdentifier->hashForEqual() ^ myLocalIDSpaceCounter->hashForEqual() ^ myEnt->hashForEqual() ^ myEmptyClubID->hashForEqual() ^ myPublicClubID->hashForEqual() ^ myAdminClubID->hashForEqual();
}
/* accessing */


void BeGrandMap::acceptConnections (BooleanVar open){
	/* See FeAdminer */
	
	myAcceptingConnectionsFlag = open;
}


RPTR(ID) BeGrandMap::assignID (APTR(BeRangeElement) value){
	/* Remember the two way association between value and its new ID. */
	
	SPTR(ID) iD;
	
	/* Known bug !!!! */
	
	/* what if the ID has already been assigned by the grantee? */
	iD = this->newID();
	if (!this->tryIntroduce(iD, value)) {
		BLAST(IDAlreadyUsed);
	}
	WPTR(ID) 	returnValue;
	returnValue = iD;
	return returnValue;
}


BooleanVar BeGrandMap::tryIntroduce (APTR(ID) iD, APTR(BeRangeElement) value){
	/* Remember the two way association between value and the 
	supplied ID. */
	
	if (myRangeElements->includesKey(iD)) {
		return FALSE;
	}
	/* Hack !!!! */
	
	/* The number below comes frojm my memory of how big a 
		GrandMap assign can be. */
	BEGIN_CONSISTENT(6) {
		SPTR(HeaperAsPosition) hap;
		SPTR(IDRegion) OR(NULL) already;
		
		/* Thing to do !!!! */
		
		/* Decide about multiple IDs */
		hap = HeaperAsPosition::make (value);
		already = CAST(IDRegion,myRangeElementIDs->fetch(hap));
		if (already == NULL) {
			myRangeElementIDs->introduce(hap, iD->asRegion());
		} else {
			if (value->isKindOf(cat_BeClub)) {
				BLAST(ClubMustHaveUniqueID);
			}
			myRangeElementIDs->replace(hap, already->with(iD));
		}
		myRangeElements->introduce(iD, value);
	} END_CONSISTENT;
	return TRUE;
}


RPTR(ID) BeGrandMap::clubDirectoryID (){
	return (ID*) myClubDirectoryID;
}


RPTR(FilterSpace) BeGrandMap::endorsementFilterSpace (){
	return (FilterSpace*) myEndorsementFilterSpace;
}


RPTR(CrossSpace) BeGrandMap::endorsementSpace (){
	return (CrossSpace*) myEndorsementSpace;
}


RPTR(BeRangeElement) OR(NULL) BeGrandMap::fetch (APTR(ID) iD){
	/* The actual BeRangeElement at that ID, or NULL if there is none */
	
	return CAST(BeRangeElement,myRangeElements->fetch(iD));
}


RPTR(BeClub) OR(NULL) BeGrandMap::fetchClub (APTR(ID) OR(NULL) iD){
	/* If there is a club at the given ID, return it. */
	
	if (iD == NULL) {
		return NULL;
	}
	BEGIN_CHOOSE(this->get(iD)) {
		BEGIN_KIND(BeClub,club) {
			WPTR(BeClub) OR(NULL) 	returnValue;
			returnValue = club;
			return returnValue;
		} END_KIND;
		BEGIN_OTHERS {
			
		} END_OTHERS;
	} END_CHOOSE;
	return NULL;
}


RPTR(FeEdition) BeGrandMap::gateLockSmithEdition (){
	WPTR(FeEdition) 	returnValue;
	returnValue = FeEdition::on(myGateLockSmithEdition);
	return returnValue;
}


RPTR(BeRangeElement) BeGrandMap::get (APTR(ID) iD){
	/* The actual BeRangeElement at that ID, or blast if there is none */
	
	return CAST(BeRangeElement,myRangeElements->get(iD));
}


RPTR(BeClub) BeGrandMap::getClub (APTR(ID) iD){
	/* Get a BeClub from the GrandMap. */
	
	return CAST(BeClub,this->get(iD));
}


RPTR(FeRangeElement) BeGrandMap::getFe (APTR(ID) iD){
	/* Get what is at the the given ID as a front end object; 
	blast if there is nothing there */
	
	/* Known bug !!!! */
	
	/* This doesn't supply a label for Editions. */
	WPTR(FeRangeElement) 	returnValue;
	returnValue = this->get(iD)->makeFe(NULL);
	return returnValue;
}


RPTR(Counter) BeGrandMap::getOrMakeIDCounter (APTR(Sequence) OR(NULL) backend, IntegerVar number){
	/* Get a canonical Counter for an IDSpace, or make a new one */
	
	SPTR(Counter) result;
	SPTR(Sequence) theBackend;
	
	if (backend != NULL) {
		theBackend = backend;
	} else {
		if (number < IntegerVarZero) {
			theBackend = Sequence::zero();
		} else {
			theBackend = this->identifier();
		}
	}
	result = CAST(Counter,myIDCounters->fetch(Tuple::two(theBackend, IntegerPos::make (number))));
	if (result == NULL) {
		/* Thing to do !!!! */
		
		/* figure out good batching */
		result = Counter::make (1, 20);
		myIDCounters->introduce(Tuple::two(theBackend, IntegerPos::make (number)), result);
	}
	WPTR(Counter) 	returnValue;
	returnValue = result;
	return returnValue;
}


RPTR(BeIDHolder) BeGrandMap::getOrMakeIDHolder (APTR(ID) iD){
	/* If there is already an IDHolder for the ID then return it, 
	otherwise make one */
	
	SPTR(BeIDHolder) result;
	
	result = CAST(BeIDHolder,myIDHolders->fetch(iD));
	/* Make one and remember it for canonicalization */
	if (result == NULL) {
		BEGIN_CONSISTENT(666) {
			result = BeIDHolder::make (iD);
			myIDHolders->introduce(iD, result);
		} END_CONSISTENT;
	}
	WPTR(BeIDHolder) 	returnValue;
	returnValue = result;
	return returnValue;
}


RPTR(FilterSpace) BeGrandMap::globalIDFilterSpace (){
	/* The FilterSpace on global IDSpace */
	
	return (FilterSpace*) myGlobalIDFilterSpace;
}


RPTR(IDSpace) BeGrandMap::globalIDSpace (){
	/* The global IDSpace */
	
	return (IDSpace*) myGlobalIDSpace;
}


void BeGrandMap::grant (APTR(ID) clubID, APTR(IDRegion) globalIDs){
	/* See FeAdminer */
	
	SPTR(BeEdition) newGrants;
	
	newGrants = myGrants->replace(this->newEditionWithAll(globalIDs, this->carrier(this->getClub(clubID))));
	BEGIN_CONSISTENT(1) {
		myGrants = newGrants;
		this->diskUpdate();
	} END_CONSISTENT;
}


RPTR(ID) BeGrandMap::grantAt (APTR(ID) iD){
	/* Who has been granted authority to assign that ID */
	
	WPTR(ID) 	returnValue;
	returnValue = this->iDOf(myGrants->get(iD)->getOrMakeBe());
	return returnValue;
}


RPTR(TableStepper) OF2(ID,IDRegion) BeGrandMap::grants (APTR(IDRegion) OR(NULL) clubIDs, APTR(IDRegion) OR(NULL) globalIDs){
	/* See FeAdminer */
	
	SPTR(BeEdition) theEdition;
	
	if (globalIDs == NULL) {
		theEdition = myGrants;
	} else {
		theEdition = myGrants->copy(globalIDs);
	}
	WPTR(TableStepper) OF2(ID,IDRegion) 	returnValue;
	returnValue = GrantStepper::make (theEdition, clubIDs);
	return returnValue;
}


RPTR(Sequence) BeGrandMap::identifier (){
	return (Sequence*) myIdentifier;
}


RPTR(ID) BeGrandMap::iDOf (APTR(BeRangeElement) value){
	/* Find the ID of a BeRangeElement. Blast if there is no ID 
	or if there is more than one */
	
	SPTR(IDRegion) OR(NULL) result;
	
	result = CAST(IDRegion,myRangeElementIDs->fetch(HeaperAsPosition::make (value)));
	if (result == NULL) {
		BLAST(DoesNotHaveAnID);
	}
	if (!(result->count() == 1)) {
		BLAST(HasMultipleIDs);
	}
	return CAST(ID,result->theOne());
}


RPTR(IDRegion) BeGrandMap::iDsOf (APTR(BeRangeElement) value){
	/* Find the IDs of a BeRangeElement, whether there are none, 
	one, or several */
	
	SPTR(IDRegion) OR(NULL) result;
	
	result = CAST(IDRegion,myRangeElementIDs->fetch(HeaperAsPosition::make (value)));
	if (result == NULL) {
		return CAST(IDRegion,myGlobalIDSpace->emptyRegion());
	}
	WPTR(IDRegion) 	returnValue;
	returnValue = result;
	return returnValue;
}


BooleanVar BeGrandMap::isAcceptingConnections (){
	/* See FeAdminer */
	
	return myAcceptingConnectionsFlag;
}


RPTR(ID) BeGrandMap::newID (){
	WPTR(ID) 	returnValue;
	returnValue = myGlobalIDSpace->newID();
	return returnValue;
}


RPTR(IDSpace) BeGrandMap::newIDSpace (){
	/* Make a new globally unique IDSpace */
	
	WPTR(IDSpace) 	returnValue;
	returnValue = IDSpace::make (this->identifier(), myLocalIDSpaceCounter->increment());
	return returnValue;
}


RPTR(ID) BeGrandMap::placeOwnerID (APTR(ID) iD){
	/* The ID of the Club which owns whatever is at the given ID */
	
	SPTR(BeRangeElement) value;
	
	value = this->fetch(iD);
	if (value != NULL) {
		WPTR(ID) 	returnValue;
		returnValue = value->owner();
		return returnValue;
	}
	/* Figure out who owns PlaceHolders */
	BLAST(NOT_YET_IMPLEMENTED);
	/* fodder */
	return NULL;
}


void BeGrandMap::setGateLockSmithEdition (APTR(FeEdition) edition){
	if (!FeLockSmith::spec()->certify(edition)) {
		BLAST(MustBeValidLockSmith);
	}
	myGateLockSmithEdition = edition->beEdition();
}


RPTR(ScruTable) OF2(Sequence,CrossRegion) BeGrandMap::wrapperEndorsements (){
	/* A mapping from wrapper names to endorsements */
	
	/* Ravi -- Thing to do !!!! */
	
	/* Figure out if there is a better way to do this */
	return (ImmuTable*) myWrapperEndorsements;
}
/* making editions */


RPTR(BeEdition) BeGrandMap::newDataEdition (
		APTR(PrimDataArray) values, 
		APTR(XnRegion) keys, 
		APTR(OrderSpec) ordering)
{
	/* Creates an Edition mapping from a Region of keys to the 
	values in an array. The ordering specifies the correspondance 
	between the keys and the indices in the array.
		The Region must have the same count as the array.
		You must give an owner for the newly created DataHolders. */
	
	SPTR(OrglRoot) result;
	IntegerVar offset;
	SPTR(XnRegion) remainder;
	
	if (keys->isEmpty()) {
		WPTR(BeEdition) 	returnValue;
		returnValue = this->newEmptyEdition(keys->coordinateSpace());
		return returnValue;
	}
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					if (values->count() <= Ent::tableSegmentMaxSize().asLong()) {
						WPTR(BeEdition) 	returnValue;
						returnValue = BeEdition::make (
							OrglRoot::makeData(keys, ordering, values));
						return returnValue;
					}
					result = OrglRoot::make (ordering->coordinateSpace());
					offset = Int32Zero;
					remainder = keys;
					while (offset < values->count()) {
						Int32 count;
						SPTR(OrglRoot) oroot;
						SPTR(PrimDataArray) array;
						SPTR(XnRegion) region;
						
						count = min(Ent::tableSegmentMaxSize().asLong(), values->count() - offset.asLong());
						array = CAST(PrimDataArray,values->copy(count, offset.asLong()));
						region = remainder->chooseMany(count, ordering);
						oroot = 
								OrglRoot::makeData(IntegerMapping::make (-offset)->ofAll(region), ordering, array);
						result = result->combine(oroot->transformedBy(IntegerMapping::make (offset)));
						remainder = remainder->minus(region);
						offset += count;
					}
					WPTR(BeEdition) 	returnValue;
					returnValue = BeEdition::make (result);
					return returnValue;
				}
			}
		}
	}
}


RPTR(BeEdition) BeGrandMap::newEditionWith (APTR(Position) key, APTR(BeCarrier) value){
	/* A single key-value mapping */
	
	
	/* Hack !!!! */
	
	/* What should the bertCrum be? */
	{	FLUID_BIND(CurrentTrace,value->rangeElement()->hCrum()->hCut()->newSuccessor()) {
			{	FLUID_BIND(CurrentBertCrum,value->rangeElement()->bertCrum()) {
					SPTR(XnRegion) region;
					
					region = key->asRegion();
					WPTR(BeEdition) 	returnValue;
					returnValue = BeEdition::make (ActualOrglRoot::make (Loaf::make (region, value), region));
					return returnValue;
				}
			}
		}
	}
}


RPTR(BeEdition) BeGrandMap::newEditionWithAll (APTR(XnRegion) keys, APTR(BeCarrier) value){
	/* A single key-value mapping */
	
	/* Hack !!!! */
	
	/* What should the bertCrum be? */
	if (keys->isEmpty()) {
		WPTR(BeEdition) 	returnValue;
		returnValue = this->newEmptyEdition(keys->coordinateSpace());
		return returnValue;
	}
	{	FLUID_BIND(CurrentTrace,value->rangeElement()->hCrum()->hCut()->newSuccessor()) {
			{	FLUID_BIND(CurrentBertCrum,value->rangeElement()->bertCrum()) {
					WPTR(BeEdition) 	returnValue;
					returnValue = BeEdition::make (ActualOrglRoot::make (Loaf::make (keys, value), keys));
					return returnValue;
				}
			}
		}
	}
}


RPTR(BeEdition) BeGrandMap::newEmptyEdition (APTR(CoordinateSpace) cs){
	/* Create an empty Edition.  This should really be canonicalized. */
	
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					BEGIN_CONSISTENT(4) {
						WPTR(BeEdition) 	returnValue;
						returnValue = BeEdition::make (OrglRoot::make (cs));
						return returnValue;
					} END_CONSISTENT;
				}
			}
		}
	}
}


RPTR(BeEdition) BeGrandMap::newPlaceHolders (APTR(XnRegion) region){
	/* Make an Edition with a region full of unique PlaceHolders */
	
	/* Ravi -- Thing to do !!!! */
	
	/* rename to newPlaceHolders */
	if (region->isEmpty()) {
		WPTR(BeEdition) 	returnValue;
		returnValue = this->newEmptyEdition(region->coordinateSpace());
		return returnValue;
	}
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					WPTR(BeEdition) 	returnValue;
					returnValue = BeEdition::make (OrglRoot::make (region));
					return returnValue;
				}
			}
		}
	}
}


RPTR(BeEdition) BeGrandMap::newValueEdition (
		APTR(PtrArray) OF1(FeRangeElement) values, 
		APTR(XnRegion) keys, 
		APTR(OrderSpec) ordering)
{
	/* Creates an Edition mapping from a Region of keys to the 
	values in an array. The ordering specifies the correspondance 
	between the keys and the indices in the array.
		The Region must have the same count as the array. */
	/* compute the join of the existing traces and bert crums in 
	the table */
	/* make new ones if there are none */
	
	SPTR(TracePosition) trace;
	SPTR(CanopyCrum) crum;
	SPTR(BeRangeElement) rangeElement;
	
	if (keys->count() != values->count()) {
		BLAST(CountMismatch);
	}
	if (keys->isEmpty()) {
		WPTR(BeEdition) 	returnValue;
		returnValue = this->newEmptyEdition(keys->coordinateSpace());
		return returnValue;
	}
	BEGIN_CHOOSE(values->fetch(Int32Zero)){
		BEGIN_KIND(FeRangeElement,fe){
			rangeElement = fe->getOrMakeBe();
		} END_KIND;
		BEGIN_ISNULL {
			{
				BLAST(MustNotHaveNullElements);
			}
		}END_ISNULL
		
	} END_CHOOSE;
	trace = rangeElement->hCrum()->hCut();
	crum = rangeElement->bertCrum();
	{
		Int32 LoopFinal = values->count();
		Int32 i = 1;
		for (;;) {
			if (i >= LoopFinal){
				break;
			}
			{
				BEGIN_CHOOSE(values->fetch(i)){
					BEGIN_KIND(FeRangeElement,fe){
						rangeElement = fe->getOrMakeBe();
					} END_KIND;
					BEGIN_ISNULL {
						{
							BLAST(MustNotHaveNullElements);
						}
					}END_ISNULL
					
				} END_CHOOSE;
				/* Neither of these should need a 
					consistent block. */
				trace = trace->newSuccessorAfter(rangeElement->hCrum()->hCut());
				crum = crum->computeJoin(rangeElement->bertCrum());
			}
			i += 1;
		}
	}
	{	FLUID_BIND(CurrentTrace,trace) {
			{	FLUID_BIND(CurrentBertCrum,CAST(BertCrum,crum)) {
					WPTR(BeEdition) 	returnValue;
					returnValue = BeEdition::make (
						OrglRoot::make (keys, ordering, values));
					return returnValue;
				}
			}
		}
	}
}
/* making other things */


RPTR(BeCarrier) BeGrandMap::carrier (APTR(BeRangeElement) element){
	/* Return a carrier that has the rangeElement with a new 
	Label if appropriate. */
	
	if (element->isKindOf(cat_BeEdition)) {
		WPTR(BeCarrier) 	returnValue;
		returnValue = BeCarrier::make (this->newLabel(), element);
		return returnValue;
	} else {
		WPTR(BeCarrier) 	returnValue;
		returnValue = BeCarrier::make (element);
		return returnValue;
	}
}


RPTR(BeClub) BeGrandMap::newClub (APTR(FeEdition) desc, APTR(ID) iD/* = NULL*/){
	/* Make a new Club assigned to either iD or a generated ID id 
	iD is NULL. */
	
	SPTR(BeClub) result;
	
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					result = BeClub::make (desc);
				}
			}
		}
	}
	BEGIN_CONSISTENT(-1) {
		if (iD == NULL) {
			this->assignID(result);
		} else {
			if (!this->tryIntroduce(iD, result)) {
				BLAST(IllegalID);
			}
		}
		/* If we allow multiple IDs for clubs, we'll have to 
			do this in the grandMap. */
		result->updateTransitiveMemberIDs();
		result->updateTransitiveSuperClubIDs();
	} END_CONSISTENT;
	WPTR(BeClub) 	returnValue;
	returnValue = result;
	return returnValue;
}


RPTR(BeDataHolder) BeGrandMap::newDataHolder (APTR(PrimValue) value){
	/* Make a new DataHolder with the given contents. */
	
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					BEGIN_CONSISTENT(1) {
						RETURN_CONSTRUCT(BeDataHolder,(value, tcsj));
					} END_CONSISTENT;
				}
			}
		}
	}
}


RPTR(BeIDHolder) BeGrandMap::newIDHolder (APTR(ID) iD){
	/* Make a new IDHolder for the given ID. Uses an existing one 
	if it exists. */
	
	SPTR(BeIDHolder) result;
	
	result = CAST(BeIDHolder,myIDHolders->fetch(iD));
	if (result == NULL) {
		BEGIN_CONSISTENT(-1) {
			{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
					{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
							result = BeIDHolder::make (iD);
							myIDHolders->introduce(iD, result);
						}
					}
				}
			}
		} END_CONSISTENT;
	}
	WPTR(BeIDHolder) 	returnValue;
	returnValue = result;
	return returnValue;
}


RPTR(BeLabel) BeGrandMap::newLabel (){
	/* Make a new label. */
	
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					BEGIN_CONSISTENT(1) {
						RETURN_CONSTRUCT(BeLabel,());
					} END_CONSISTENT;
				}
			}
		}
	}
}


RPTR(BePlaceHolder) BeGrandMap::newPlaceHolder (){
	/* Make a new PlaceHolder. */
	
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					BEGIN_CONSISTENT(3) {
						RETURN_CONSTRUCT(BePlaceHolder,());
					} END_CONSISTENT;
				}
			}
		}
	}
}


RPTR(BeWork) BeGrandMap::newWork (APTR(FeEdition) contents){
	/* Make a new Work (without an ID) with the given contents.  
	Everything 
		 else comes from the fluid environment. */
	
	{	FLUID_BIND(CurrentTrace,myEnt->newTrace()) {
			{	FLUID_BIND(CurrentBertCrum,BertCrum::make ()) {
					WPTR(BeWork) 	returnValue;
					returnValue = BeWork::make (contents);
					return returnValue;
				}
			}
		}
	}
}
/* clubs */


RPTR(ID) BeGrandMap::accessClubID (){
	return (ID*) myAccessClubID;
}


RPTR(ID) BeGrandMap::adminClubID (){
	return (ID*) myAdminClubID;
}


RPTR(ID) BeGrandMap::archiveClubID (){
	return (ID*) myArchiveClubID;
}


RPTR(ID) BeGrandMap::emptyClubID (){
	return (ID*) myEmptyClubID;
}


RPTR(ID) BeGrandMap::publicClubID (){
	return (ID*) myPublicClubID;
}



/* ************************************************************************ *
 * 
 *                    Class BackendBootMaker 
 *
 * ************************************************************************ */



/* Initializers for BackendBootMaker */


BEGIN_INIT_TIME(BackendBootMaker,initTimeNonInherited) {
	
	Cookbook::declareCookbook("disk", cat_BeGrandMap, DiskCuisine, XppCuisine, FebeCuisine);
} END_INIT_TIME(BackendBootMaker,initTimeNonInherited);



/* Initializers for BackendBootMaker */



/* creation */


RPTR(BootPlan) BackendBootMaker::make (){
	RETURN_CONSTRUCT(BackendBootMaker,());
}
/* accessing */


RPTR(Category) BackendBootMaker::bootCategory (){
	WPTR(Category) 	returnValue;
	returnValue = cat_BeGrandMap;
	return returnValue;
}
/* protected: */


RPTR(Heaper) BackendBootMaker::bootHeaper (){
	WPTR(Heaper) 	returnValue;
	returnValue = BeGrandMap::make ();
	return returnValue;
}

	/* automatic 0-argument constructor */
BackendBootMaker::BackendBootMaker() {}



/* ************************************************************************ *
 * 
 *                    Class GrantStepper 
 *
 * ************************************************************************ */


/* create */


RPTR(TableStepper) GrantStepper::make (APTR(BeEdition) grants, APTR(IDRegion) OR(NULL) clubIDs){
	RETURN_CONSTRUCT(GrantStepper,(grants->retrieve(), clubIDs));
}
/* Has a Bundle Stepper on a piece of the Edition defining the grants 
for this Server, and views it as a sequence of associations from 
ClubIDs to IDRegions (which is the inverse of its actual format) */


/* special */


RPTR(Position) GrantStepper::position (){
	/* Ravi -- Thing to do !!!! */
	
	/* in future implementations this might also get back an ArrayBundle */
	WPTR(Position) 	returnValue;
	returnValue = CurrentGrandMap.fluidGet()->iDOf(CAST(FeElementBundle,myBundles->get())->element()->getOrMakeBe());
	return returnValue;
}
/* operations */


WPTR(Heaper) GrantStepper::fetch (){
	SPTR(FeBundle) bundle;
	
	bundle = CAST(FeBundle,myBundles->fetch());
	if (bundle == NULL) {
		return NULL;
	}
	WPTR(Heaper) 	returnValue;
	returnValue = bundle->region();
	return returnValue;
}


BooleanVar GrantStepper::hasValue (){
	return myBundles->hasValue();
}


void GrantStepper::step (){
	while (myBundles->hasValue()) {
		myBundles->step();
		{	BooleanVar crutch_Flag;
			/* myClubIDs == NULL || myClubIDs->hasMember(this->position()) */
			
			crutch_Flag = myClubIDs == NULL;
			if(!crutch_Flag) {
				crutch_Flag = myClubIDs->hasMember(this->position());
			}
			if (crutch_Flag) {
				return;
				
			}
		}
	}
}
/* create */


RPTR(Stepper) GrantStepper::copy (){
	RETURN_CONSTRUCT(GrantStepper,(myBundles->copy(), myClubIDs));
}


GrantStepper::GrantStepper (APTR(Stepper) OF1(FeBundle) bundles, APTR(IDRegion) OR(NULL) clubIDs) {
	myBundles = bundles;
	myClubIDs = clubIDs;
}

#ifndef GRANMAPX_SXX
#include "granmapx.sxx"
#endif /* GRANMAPX_SXX */


#ifndef GRANMAPP_SXX
#include "granmapp.sxx"
#endif /* GRANMAPP_SXX */



#endif /* GRANMAPX_CXX */

