/* Copyright Xanadu Operating Company.  All Rights Reserved. */

/******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Xanadu    *
* Operating Company, and considered a trade secret as defined in section     * 
* 499C of the penal code of the State of California.  Use of this information* 
* by anyone other than authorized employees of Xanadu is granted             *
* only under a  written non-disclosure agreement, expressly prescribing      * 
* the scope and  manner of such use.                                         *
*                                                                            *
***************************************************************************
Output from Objectworks for Smalltalk-80(tm), Version 2.5 of 29 July 1989
*/

#ifndef SETT_HXX
#define SETT_HXX


#ifndef TOFUX_HXX
#include "tofux.hxx"
#endif /* TOFUX_HXX */

#ifndef INTVARX_HXX
#include "intvarx.hxx"
#endif /* INTVARX_HXX */

#ifndef SETX_HXX
#include "setx.hxx"
#endif /* SETX_HXX */

#ifndef SETT_OXX
#include "sett.oxx"
#endif /* SETT_OXX */


#ifndef TESTERX_HXX
#include "testerx.hxx"
#endif /* TESTERX_HXX */


#ifndef NXCVRX_OXX
#include "nxcvrx.oxx"
#endif /* NXCVRX_OXX */

#ifndef SEQUENCX_OXX
#include "sequencx.oxx"
#endif /* SEQUENCX_OXX */

#ifndef SETP_OXX
#include "setp.oxx"
#endif /* SETP_OXX */

#ifndef TABLESX_OXX
#include "tablesx.oxx"
#endif /* TABLESX_OXX */


/* This file group has no comment */
/*  */

#include <stream.h>



/* ************************************************************************ *
 * 
 *                    Class ScruSetTester 
 *
 * ************************************************************************ */




	/* NO CLASS COMMENT */

class ScruSetTester : public Tester {

/* Attributes for class ScruSetTester */
	DEFERRED(ScruSetTester)
	COPY(ScruSetTester,BootCuisine)
	AUTO_GC(ScruSetTester)
  public: /* creation */

	
	ScruSetTester ();
	
  public: /* testing */

	
	virtual void allTestsOn (ostream& ARG(oo));
	
  public: /* tests */

	
	virtual void testContentsEqual (ostream& ARG(oo));
	
	
	virtual void testhasMember (ostream& ARG(oo));
	
	
	virtual void testIntersects (ostream& ARG(oo));
	
	
	virtual void testIsEmpty (ostream& ARG(oo));
	
	
	virtual void testIsSubsetOf (ostream& ARG(oo));
	
	
	virtual void unaryCheck (APTR(ScruSet) ARG(a));
	
  public: /* hooks: */

	
	virtual RECEIVE_HOOK void restartScruSetTester (APTR(Rcvr) ARG(rcvr));
	
  public: /* deferred: initialization */

	
	virtual RPTR(ScruSet) generateSet () DEFERRED_FUNC;
	
	
	virtual RPTR(ScruSet) generateSetContaining (APTR(Stepper) ARG(stuff)) DEFERRED_FUNC;
	
  protected: /* protected: accessing */

	
	virtual RPTR(ScruSet) getScruSet (IntegerVar ARG(number));
	
	
	virtual void setTestSets (APTR(ScruTable) OF1(ScruSet) ARG(table));
	
	
	virtual RPTR(ScruTable) OF1(ScruSet) testScruSets ();
	
  private: /* private: scruset generation */

	/* generateScruSets must generate a table of sets in the 
	following order:
		  1) an empty set
		  2) a set containing one element
		  3) a set containing one element which is different from 
	that in set 2
		  4) a set containing at least two elements, one equal to 
	the element in set 2
		  5) a set containing at least two elements, different from 
	all previous elements
		  6) a set with the same contents as set 2 not generated by copy()
		  7) a set with the same contents as set 5 not generated by copy()
		  8) a set generated by set 2 copy
		  9) a set generated by set 5 copy
		  other sets are optional and will only be tested with 
	general tests (check).
		   */
	
	virtual RPTR(ScruTable) OF1(ScruSet) generateScruSets ();
	
  private:
	NOCOPY CHKPTR(ScruTable) OF1(ScruSet) myTestSets;
};  /* end class ScruSetTester */



/* ************************************************************************ *
 * 
 *                    Class   ImmuSetTester 
 *
 * ************************************************************************ */




	/* NO CLASS COMMENT */

class ImmuSetTester : public ScruSetTester {

/* Attributes for class ImmuSetTester */
	CONCRETE(ImmuSetTester)
	COPY(ImmuSetTester,BootCuisine)
	NO_GC(ImmuSetTester)
  public: /* testing */

	
	virtual void allTestsOn (ostream& ARG(oo));
	
  public: /* accessing */

	
	virtual RPTR(ScruSet) generateSet ();
	
	
	virtual RPTR(ScruSet) generateSetContaining (APTR(Stepper) ARG(stuff));
	

	/* automatic 0-argument constructor */
  public:
	ImmuSetTester();

};  /* end class ImmuSetTester */



/* ************************************************************************ *
 * 
 *                    Class   MuSetTester 
 *
 * ************************************************************************ */




	/* NO CLASS COMMENT */

class MuSetTester : public ScruSetTester {

/* Attributes for class MuSetTester */
	DEFERRED(MuSetTester)
	COPY(MuSetTester,BootCuisine)
	NO_GC(MuSetTester)
  public: /* deferred: initialization */

	
	virtual RPTR(ScruSet) generateSet () DEFERRED_FUNC;
	
	
	virtual RPTR(ScruSet) generateSetContaining (APTR(Stepper) ARG(stuff)) DEFERRED_FUNC;
	
  public: /* tests */

	
	virtual void binaryCheck (APTR(MuSet) ARG(a), APTR(MuSet) ARG(b));
	
	
	virtual void binarySetTestsOn (ostream& ARG(oo));
	
	
	virtual void unaryCheck (APTR(ScruSet) ARG(a));
	
  public: /* testing */

	
	virtual void allTestsOn (ostream& ARG(oo));
	
  protected: /* protected: accessing */

	
	virtual RPTR(ScruTable) OF1(MuSet) testMuSets ();
	

	/* automatic 0-argument constructor */
  public:
	MuSetTester();

};  /* end class MuSetTester */



/* ************************************************************************ *
 * 
 *                    Class     HashSetTester 
 *
 * ************************************************************************ */




	/* NO CLASS COMMENT */

class HashSetTester : public MuSetTester {

/* Attributes for class HashSetTester */
	CONCRETE(HashSetTester)
	COPY(HashSetTester,BootCuisine)
	NO_GC(HashSetTester)
  public: /* tests */

	
	virtual void basicTestsOn (ostream& ARG(oo));
	
	
	virtual void doIntroduceTestsOn (ostream& ARG(oo));
	
	
	virtual void doStoreTestsOn (ostream& ARG(oo));
	
	
	virtual void doWipeTestsOn (ostream& ARG(oo));
	
	
	virtual void testBig (ostream& ARG(oo));
	
  public: /* testing */

	/* HashSetTester runTest */
	
	virtual void allTestsOn (ostream& ARG(oo));
	
  public: /* test support */

	
	virtual void introduceTestsOn (
			ostream& ARG(oo), 
			APTR(HashSet) ARG(set1), 
			APTR(SHTO) ARG(object))
	;
	
	
	virtual void removeTestsOn (
			ostream& ARG(oo), 
			APTR(HashSet) ARG(set1), 
			APTR(SHTO) ARG(object))
	;
	
	
	virtual void storeTestsOn (
			ostream& ARG(oo), 
			APTR(HashSet) ARG(set1), 
			APTR(SHTO) ARG(object))
	;
	
	
	virtual void wipeTestsOn (
			ostream& ARG(oo), 
			APTR(HashSet) ARG(set1), 
			APTR(SHTO) ARG(object))
	;
	
  public: /* accessing */

	/* ^ MuSet make		No - we're testing ActualHashSets, not MuSets. */
	
	virtual RPTR(ScruSet) generateSet ();
	
	
	virtual RPTR(ScruSet) generateSetContaining (APTR(Stepper) ARG(stuff));
	

	/* automatic 0-argument constructor */
  public:
	HashSetTester();

};  /* end class HashSetTester */



/* ************************************************************************ *
 * 
 *                    Class SetTester 
 *
 * ************************************************************************ */




	/* NO CLASS COMMENT */

class SetTester : public Tester {

/* Attributes for class SetTester */
	CONCRETE(SetTester)
	COPY(SetTester,BootCuisine)
	NO_GC(SetTester)
  public: /* testing */

	
	virtual void allTestsOn (ostream& ARG(oo));
	

	/* automatic 0-argument constructor */
  public:
	SetTester();

};  /* end class SetTester */



/* ************************************************************************ *
 * 
 *                    Class SHTO 
 *
 * ************************************************************************ */




	/* SHTO (SpecialHashTestObject) is used for testing hash 
	sets.  It stores an identifying string, along with the hash 
	that it is to return.  This allows a) system independent 
	testing - as the hash will be the same in all test output 
	files, and b) provides for testing complex hash value 
	interactions with spending years looking for the right 
	objects to generate critical hash values. */

class SHTO : public Heaper {

/* Attributes for class SHTO */
	CONCRETE(SHTO)
	AUTO_GC(SHTO)
  public: /* make */

	
	static RPTR(SHTO) make (char* ARG(aString), UInt32 ARG(aHashVal));
	
  public: /* tests */

	
	virtual UInt32 actualHashForEqual ();
	
	
	virtual BooleanVar isEqual (APTR(Heaper) ARG(other));
	
  public: /* creation */

	
	SHTO (APTR(Sequence) ARG(onString), UInt32 ARG(onHash));
	
  public: /* printing */

	
	virtual void printOn (ostream& ARG(oo));
	
  private: /* private: accessing */

	
	virtual RPTR(Sequence) stringValue ();
	
  private:
	UInt4 myHashValue;
	CHKPTR(Sequence) myStringValue;
};  /* end class SHTO */



#endif /* SETT_HXX */

